Index: fluid/Fl_Type.h
===================================================================
--- fluid/Fl_Type.h	(revision 12547)
+++ fluid/Fl_Type.h	(working copy)
@@ -382,6 +382,7 @@
   const char *image_name_;
   const char *inactive_name_;
   uchar hotspot_;
+  Fl_Widget_Tracker *wt;
 
 protected:
 
Index: fluid/Fl_Widget_Type.cxx
===================================================================
--- fluid/Fl_Widget_Type.cxx	(revision 12547)
+++ fluid/Fl_Widget_Type.cxx	(working copy)
@@ -158,6 +158,8 @@
   if (reading_file) t->o->label(0);
   else if (t->o->label()) t->label(t->o->label()); // allow editing
   t->o->user_data((void*)t);
+  // Use Fl_Widget_Tracker to see if the widget got deleted (STR #3427)
+  t->wt = new Fl_Widget_Tracker(t->o);
   // Put it in the parent:
   //  ((Fl_Group *)(p->o))->add(t->o); (done by Fl_Type::add())
   // add to browser:
@@ -193,6 +195,8 @@
   redraw();
 }
 
+// static int nwt = 0; // Debug STR #3427
+
 Fl_Widget_Type::Fl_Widget_Type() {
   for (int n=0; n<NUM_EXTRA_CODE; n++) {extra_code_[n] = 0; }
   subclass_ = 0;
@@ -205,14 +209,27 @@
   xclass = 0;
   o = 0;
   public_ = 1;
+  wt = 0; // Fl_Widget_Tracker (STR #3427)
+  // nwt++; // Debug STR #3427
+  // fprintf(stderr, "c'tor Fl_Widget_Type [%3d]: %p\n", nwt, this);
 }
 
 Fl_Widget_Type::~Fl_Widget_Type() {
+  // fprintf(stderr, "d'tor Fl_Widget_Type [%3d]: %p\n", nwt--, this);
   if (o) {
-    o->hide();
-    if (o->parent()) ((Fl_Group*)o->parent())->remove(*o);
-    delete o;
+    if (wt && wt->exists()) {
+      // fprintf(stderr, "~Fl_Widget_Type(): o = %p, wt = %p, wt->widget() = %p\n",
+      //         o, wt, wt->widget());
+      o->hide();
+      if (o->parent()) ((Fl_Group*)o->parent())->remove(*o);
+      delete o;
+    } else {
+      // fprintf(stderr, "--- warning: ~Fl_Widget_Type() --- widget (%p) was already deleted!\n", o);
+    }
+    delete wt;
+    wt = 0;
   }
+  o = 0;
   if (subclass_) free((void*)subclass_);
   if (tooltip_) free((void*)tooltip_);
   if (image_name_) {
Index: fluid/fluid.cxx
===================================================================
--- fluid/fluid.cxx	(revision 12547)
+++ fluid/fluid.cxx	(working copy)
@@ -437,6 +437,7 @@
     svp.set("tab", sv_tab->find(sv_tab->value()));
     save_position(sourceview_panel,"sourceview_pos");
     delete sourceview_panel;
+    sourceview_panel = 0;
   }
   if (about_panel)
     delete about_panel;
